MrSID Decode SDK for Raster Reference Manual 9.5.4.4709

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
LTIOMemStream Class Reference

Stream which wraps an array of bytes in memory. More...

`#include <lt_ioMemStream.h>`

Inheritance diagram for LTIOMemStream:
[legend]
Collaboration diagram for LTIOMemStream:
[legend]

## Public Member Functions
| LTIOMemStream ()
virtual | ~LTIOMemStream ()
virtual bool | isEOF ()
| Test for end-of-stream. More...
virtual bool | isOpen ()
| Test for stream openness. More...
virtual LT_STATUS | open ()
| Opens the stream. More...
virtual LT_STATUS | close ()
| Closes the stream. More...
virtual lt_uint32 | read (lt_uint8 *pDest, lt_uint32 numBytes)
| Retrieve the specified number of bytes from the data source and place them in pDest. More...
virtual lt_uint32 | write (const lt_uint8 *pSrc, lt_uint32 numBytes)
| Store the specified number of bytes in the data source. More...
virtual LT_STATUS | seek (lt_int64 offset, LTIOSeekDir origin)
| Moves the data access position to origin + offset. More...
virtual lt_int64 | tell ()
| Returns the current data access position as an offset from the start of the data. More...
virtual LTIOStreamInf * | duplicate ()
| Clone the stream. More...
virtual LT_STATUS | getLastError () const
| Get status code of last error event. More...
virtual const char * | getID () const
| Get a URI describing the stream object. More...
Initialization functions
virtual LT_STATUS | initialize (void *data, lt_uint32 size)
| Initializes the stream. More...
virtual LT_STATUS | initialize (lt_uint32 size)
| Initializes the stream. More...
Public Member Functions inherited from LTIOStreamInf
virtual | ~LTIOStreamInf ()=0
virtual char * | readString (int delimiter= '\0')
| read a delimiter-terminated string More...

## Protected Attributes
lt_uint8 * | m_data
| pointer to buffer More...
lt_uint32 | m_size
| size of buffer More...
lt_uint32 | m_cur
| current position More...
bool | m_ownsData
| data ownership More...
bool | m_isOpen
| openness More...
bool | m_isEOF

## Detailed Description

The buffer is of a fixed size and does not grow or shrink.

Definition at line 27 of file lt_ioMemStream.h.

## Constructor & Destructor Documentation

LTIOMemStream::LTIOMemStream | ( | ) |  |

virtual LTIOMemStream::~LTIOMemStream | ( | ) |  |
| virtual

## Member Function Documentation

virtual LT_STATUS LTIOMemStream::close | ( | ) |  |
| virtual

Puts the stream in a state that does not allow data access. May free up resources, but only in such a way that doesn't inhibit successful future calls to open()

Return values

  LT_STS_Success | On success, or if the stream is already closed.
  LT_STS_Failure | Otherwise.

Implements LTIOStreamInf.

virtual LTIOStreamInf* LTIOMemStream::duplicate | ( | ) |  |
| virtual

Create new stream of the same type with the same initialization parameters. The transmission of these parameters is the responsibility of the derived type. The new stream should initially return false for isOpen().

Return values

  NULL | the stream could not be duplicated; valid LTIOStreamInf* otherwise.

Implements LTIOStreamInf.

virtual const char* LTIOMemStream::getID | ( | ) |  | const
| virtual

This function returns a UTF-8, null-terminated string which is a URI describing the origin of the stream object – for example, "file://foo.txt" or "lt_memstream:". This string is only intended for diagnostic purposes, i.e. it may not be valid to pass it to the ctor in an attempt to reopen the stream.

Return values

  uri | the uri string

Implements LTIOStreamInf.

virtual LT_STATUS LTIOMemStream::getLastError | ( | ) |  | const
| virtual

read(), write(), tell(), and duplicate() do not explicitly return status codes in the event of an error. When an error has occurred, this function returns the appropriate status code. Note calling this function after a successful I/O operation will return an undefined value.

Return values

  status | the error code

Implements LTIOStreamInf.

virtual LT_STATUS LTIOMemStream::initialize | ( | void * | data,
|  | lt_uint32 | size
| ) |  |
| virtual

Parameters

  data | pointer to start of buffer
  size | size of buffer in bytes

virtual LT_STATUS LTIOMemStream::initialize | ( | lt_uint32 | size) |  |
| virtual

This version internally allocates a buffer of the specified size.

Parameters

  size | size of buffer in bytes

virtual bool LTIOMemStream::isEOF | ( | ) |  |
| virtual

Returns true after the first read operation that attempts to read past the end of the stream. It returns false if the current position is not end of stream.

Return values

  true | end of stream
  false | otherwise

Implements LTIOStreamInf.

virtual bool LTIOMemStream::isOpen | ( | ) |  |
| virtual

Return values

  true | The stream is open
  false | otherwise

Implements LTIOStreamInf.

virtual LT_STATUS LTIOMemStream::open | ( | ) |  |
| virtual

Opening a stream puts it in a state that allows data access based on cached initialization parameters.

Return values

  LT_STS_IOStreamUninitialized | The stream has not been initialized with enough information to open the stream
  LT_STS_IOStreamInvalidState | The stream is already open
  LT_STS_Success | On success.
  LT_STS_Failure | Failure.
  other | Implementations may return other codes

Implements LTIOStreamInf.

virtual lt_uint32 LTIOMemStream::read | ( | lt_uint8 * | pDest,
|  | lt_uint32 | numBytes
| ) |  |
| virtual

Parameters

  pDest | buffer in which to store read data
  numBytes | number of bytes to read from stream

Return values

  numBytes | The number of bytes actually read

Implements LTIOStreamInf.

virtual LT_STATUS LTIOMemStream::seek | ( | lt_int64 | offset,
|  | LTIOSeekDir | origin
| ) |  |
| virtual

Parameters

  offset | number of bytes from origin at which to the next read or write will take place
  origin | place in stream from which to seek

Return values

  LT_STS_IOStreamUnsupported | The stream is not seekable
  LT_STS_IOStreamInvalidArgs | The offset and origin do not specify a valid location in the stream
  LT_STS_Success | On success
  LT_STS_Failure | Otherwise
  other | Implementations may return other codes

Implements LTIOStreamInf.

virtual lt_int64 LTIOMemStream::tell | ( | ) |  |
| virtual

Return values

  postion | Number of bytes from the start of the data
  -1 | On error.
  other | Implementations may return other codes

Implements LTIOStreamInf.

virtual lt_uint32 LTIOMemStream::write | ( | const lt_uint8 * | pSrc,
|  | lt_uint32 | numBytes
| ) |  |
| virtual

Parameters

  pSrc | buffer from which to store data
  numBytes | number of bytes to write to stream

Return values

  numBytes | number of bytes actually written

Implements LTIOStreamInf.

## Member Data Documentation

lt_uint32 LTIOMemStream::m_cur
| protected

Definition at line 76 of file lt_ioMemStream.h.

lt_uint8* LTIOMemStream::m_data
| protected

Definition at line 70 of file lt_ioMemStream.h.

bool LTIOMemStream::m_isEOF
| protected

Definition at line 84 of file lt_ioMemStream.h.

bool LTIOMemStream::m_isOpen
| protected

Definition at line 82 of file lt_ioMemStream.h.

bool LTIOMemStream::m_ownsData
| protected

Definition at line 79 of file lt_ioMemStream.h.

lt_uint32 LTIOMemStream::m_size
| protected

Definition at line 73 of file lt_ioMemStream.h.

The documentation for this class was generated from the following file:

- lt_ioMemStream.h

LizardTech